#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mpi.h"

#define BUFSIZE 200

int main(int argc, char **argv)
{
  int myrank, P, dest, tag, i;
  char buffer[BUFSIZE];
  MPI_Status status;

  MPI_Init(&argc, &argv);

  MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
  MPI_Comm_size(MPI_COMM_WORLD, &P);

  if(myrank!=0)
    {
      sprintf(buffer, "Message from process %d", myrank);
      dest = 0;
      tag = 0;
      MPI_Send(buffer, strlen(buffer)+1, MPI_CHAR, dest, tag, MPI_COMM_WORLD);
    }
  else
      for(i=1; i<P; i++)
	{
	  MPI_Recv(buffer, BUFSIZE, MPI_CHAR, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, &status);
	  printf("Received from process %d with tag %d: %s\n", status.MPI_SOURCE, status.MPI_TAG, buffer);
	}

  MPI_Finalize();
  return 0;
}
